<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "social_enhance_token".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "SocialEnhanceToken".
 *
 * Columns in table "social_enhance_token" available as properties of the model,
 * followed by relations of table "social_enhance_token" available as properties of the model.
 *
 *
 *
 * @property integer $id
 * @property integer $listing_type_id
 * @property string $profile_id
 * @property string $profile_name
 * @property string $access_token
 * @property string $oauth_token
 * @property string $oauth_token_secret
 * @property string $auth_expire
 * @property string $fb_token_expiration_date
 * @property string $date_added
 * @property string $date_updated
 *
 * @property ListingType $listingType
 */
abstract class BaseSocialEnhanceToken extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'social_enhance_token';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'SocialEnhanceToken|SocialEnhancesToken', $n);
    }

    public static function representingColumn()
    {
        return 'profile_id';
    }

    public function rules()
    {
        return array(
            array('listing_type_id', 'required'),
            array('listing_type_id', 'numerical', 'integerOnly' => true),
            array('profile_id, auth_expire', 'length', 'max' => 25),
            array('profile_name, access_token, oauth_token, oauth_token_secret', 'length', 'max' => 255),
            array('fb_token_expiration_date, date_updated, date_added', 'safe'),
            array(
                'profile_id, profile_name, access_token, oauth_token, oauth_token_secret, auth_expire,
                fb_token_expiration_date, date_updated, date_added',
                'default', 'setOnEmpty' => true, 'value' => null
            ),
            array(
                'id, listing_type_id, profile_id, profile_name, access_token,
                oauth_token, oauth_token_secret, auth_expire, fb_token_expiration_date,
                date_updated, date_added',
                'safe', 'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'listingType' => array(self::BELONGS_TO, 'ListingType', 'listing_type_id'),
            'providerPracticeSocialEnhance' => array(
                self::HAS_MANY,
                'ProviderPracticeSocialEnhance',
                'social_enhance_token_id'
            ),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'listing_type_id' => null,
            'profile_id' => Yii::t('app', 'App Type'),
            'profile_name' => Yii::t('app', 'Profile Name'),
            'access_token' => Yii::t('app', 'Access Token'),
            'oauth_token' => Yii::t('app', 'Oauth Token'),
            'oauth_token_secret' => Yii::t('app', 'Oauth Token Secret'),
            'auth_expire' => Yii::t('app', 'Auth Expire'),
            'fb_token_expiration_date' => Yii::t('app', 'Fb Token Expiration Date'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'listingType' => null,
            'providerPracticeSocialEnhance' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('listing_type_id', $this->listing_type_id);
        $criteria->compare('profile_id', $this->profile_id, true);
        $criteria->compare('profile_name', $this->profile_name, true);
        $criteria->compare('access_token', $this->access_token, true);
        $criteria->compare('oauth_token', $this->oauth_token, true);
        $criteria->compare('oauth_token_secret', $this->oauth_token_secret, true);
        $criteria->compare('auth_expire', $this->auth_expire, true);
        $criteria->compare('fb_token_expiration_date', $this->fb_token_expiration_date, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }
}
